﻿using System;
using System.Collections.Generic;
using System.Runtime.InteropServices;
using System.Linq;
using System.Text;
using System.Windows.Forms;

//sample peid plugin in c# - dzzie http://sandsprite.com

namespace peid_csharp_sample {

        public interface ICPlugin {
            int DoPluginAction();
        }

        public static class c_api {
            [DllImport("cs_stub.dll")]
            public static extern int GetHwnd();

            [DllImport("cs_stub.dll")]
            private static extern int GetFile(StringBuilder fname);

            [DllImport("cs_stub.dll")]
            public static extern void ShutDown();

            public static string GetFile(){
                StringBuilder cb = new StringBuilder(500);
                int len = GetFile(cb);
                return cb.ToString();
            }
        } 


        public class CPlugin : ICPlugin {
            public int DoPluginAction() {
                Form1 myForm;
                GETHWND hw = new GETHWND( c_api.GetHwnd() );
                IWin32Window hwnd = hw;
                myForm = new Form1();
                myForm.ShowDialog(hwnd); ; //has to be modal & owned by PEiD
                return 1;

            }
        }

        public class GETHWND : IWin32Window { //stupid csharp cast couldnt figure out other way
            private int myVal;
            public IntPtr Handle {  get { return (IntPtr)myVal; } }
            public GETHWND(int x) { myVal = x; }
        }

    }