#include <windows.h>
//#include "defs.h"
#include <stdio.h>

char *menu_text = "C# PEId sample - dzzie";
LPOLESTR   my_plugin_lib_name = OLESTR("peid_csharp_sample.CPlugin");

IDispatch *IDisp;
int global_hMainDlg    = 0;
char global_Fname[500] = {0};
char gErrMsg[1000]     = {0};

int Launch_ActiveX_Dll();

//exports used by c# through DllImport 
//------------------------------------------------
int __stdcall GetFile(char *szFname){
	strncpy(szFname,global_Fname,499);
	return strlen(global_Fname);
}

int __stdcall GetHwnd(){  
	return global_hMainDlg;
}

void __stdcall ShutDown(void){
	
	 try{
		if(IDisp) IDisp->Release();
	 }catch(...){};

}
//------------------------------------------------


DWORD DoMyJob(HWND hMainDlg, char *szFname, DWORD lpReserved, LPVOID lpParam)
{
	//hMainDlg: HWND of PEiD window
	//szFname: Filename
	//lpReserved: PEiD passes 'PEiD' as the value
	//lpParam: NULL passed, for future use
 
	// Write your main code here
	//save globals for use in call back

    global_hMainDlg = (int)hMainDlg;
	strncpy(global_Fname, szFname, 499);
	
	if(Launch_ActiveX_Dll()==0){
		MessageBox( hMainDlg, gErrMsg, "Error Launching Plugin",0);
	}

	return 1;

}

LPSTR LoadDll()
{
	return menu_text;
}


BOOL WINAPI DllMain(HINSTANCE hinstDLL, DWORD fdwReason, LPVOID lpvReserved)
{
	switch(fdwReason)
	{
		case DLL_PROCESS_ATTACH:
		break;

		case DLL_THREAD_ATTACH:
		break;

		case DLL_THREAD_DETACH:
		break;
		
		case DLL_PROCESS_DETACH:
		break;
	}
	return TRUE;
}


int Launch_ActiveX_Dll(){

    //Create an instance of our VB COM object, and execute
	//one of its methods so that it will load up and show a UI
	//for us, then it uses our other exports to access peid plugin API
	//methods

	CLSID      clsid;
	HRESULT	   hr;
	

    //LPOLESTR   p = my_plugin_lib_name;

    hr = CoInitialize(NULL);

	 hr = CLSIDFromProgID( my_plugin_lib_name , &clsid);
	 if( hr != S_OK  ){
		 sprintf(gErrMsg, "Failed to get Clsid %s from string\n", my_plugin_lib_name );
		 return 0;
	 }

	 // create an instance and get IDispatch pointer
	 hr =  CoCreateInstance( clsid,
							 NULL,
							 CLSCTX_INPROC_SERVER,
							 IID_IDispatch  ,
							 (void**) &IDisp
						   );

	 if ( hr != S_OK )
	 {
	   sprintf(gErrMsg, "CoCreate failed");
	   return 0;
	 }

	 OLECHAR *sMethodName = OLESTR("DoPluginAction");
	 DISPID  dispid; // long integer containing the dispatch ID

	 // Get the Dispatch ID for the method name
	 hr=IDisp->GetIDsOfNames(IID_NULL,&sMethodName,1,LOCALE_USER_DEFAULT,&dispid);
	 if( FAILED(hr) ){
	    sprintf(gErrMsg,"GetIDS failed");
		return 0;
	 }

	 DISPPARAMS dispparams;
	 VARIANTARG vararg[1]; //function takes one argument
	 VARIANT    retVal;

	 VariantInit(&vararg[0]);
	 /*
	 vararg[0].vt = VT_BSTR; //our argument is a BSTR type
	 vararg[0].bstrVal = SysAllocString(L"c:\\autoexec.bat"); //set string value 
	 */
	 dispparams.rgvarg = &vararg[0];
	 dispparams.cArgs = 0;  // num of args function takes
	 dispparams.cNamedArgs = 0;

	 // and invoke the method
	 hr=IDisp->Invoke( dispid, IID_NULL, LOCALE_USER_DEFAULT, DISPATCH_METHOD, &dispparams, &retVal, NULL, NULL);
	
	 /*
	 if( retVal.vt != VT_BOOL ){ 
			//cout << "Wrong return type from COM Function" ;
			return 0;
	 }
	

	 char buf[256];
	 sprintf(buf,"File %s", (retVal.boolVal ? "Exists" : "Not Found") ) ;
	 MessageBox(0,buf,"",0);
	 */

	 return 1;


}


